Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1354184 - Review Request: qhttpengine - HTTP server for Qt applications
Summary: Review Request: qhttpengine - HTTP server for Qt applications
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Igor Gnatenko
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: qt-reviews
TreeView+ depends on / blocked
 
Reported: 2016-07-10 12:19 UTC by Raphael Groner
Modified: 2016-07-22 15:59 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-07-21 23:21:14 UTC
ignatenko: fedora-review+


Attachments (Terms of Use)

Description Raphael Groner 2016-07-10 12:19:55 UTC
Spec URL: https://raphgro.fedorapeople.org/review/util/qhttpengine.spec
SRPM URL: https://raphgro.fedorapeople.org/review/util/qhttpengine-0.1.0-1.fc24.src.rpm

Description: HTTP server for Qt applications
Simple set of classes for developing HTTP server applications in Qt.

Fedora Account System Username: raphgro

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=14847630

Note: Main purpose of this package is to provide an (optional) feature of nitroshare, a desktop util to easily share data over networks.

Comment 1 Raphael Groner 2016-07-10 12:25:27 UTC
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=14847721

Comment 2 Igor Gnatenko 2016-07-10 13:17:06 UTC
> Provides:       cmake(%{modname})
I thought that it should come automatically... Rex?

> Requires:       %{name} = %{version}-%{release}
Missing %{?_isa}

> %cmake
I would recommend to make out-of-tree builds

Others from first glance looks great!

Comment 3 Igor Gnatenko 2016-07-10 13:30:26 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- ldconfig called in %post and %postun if required.
  Note: /sbin/ldconfig not called in qhttpengine
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Shared_Libraries
- %check is present and all tests pass.
  Note: test suite is not built/ran
- qhttpengine-devel.x86_64: E: useless-provides cmake(QHttpEngine)
  Note: yeah, remove it
- BuildRequires: gcc-c++ is missing
- Would be great to build docs as well

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 15 files have
     unknown license. Detailed output of licensecheck in
     /home/brain/1354184-qhttpengine/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     qhttpengine-devel , qhttpengine-debuginfo
[!]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: qhttpengine-0.1.0-1.fc24.x86_64.rpm
          qhttpengine-devel-0.1.0-1.fc24.x86_64.rpm
          qhttpengine-debuginfo-0.1.0-1.fc24.x86_64.rpm
          qhttpengine-0.1.0-1.fc24.src.rpm
qhttpengine.x86_64: E: library-without-ldconfig-postin /usr/lib64/libQHttpEngine.so.0.1.0
qhttpengine.x86_64: E: library-without-ldconfig-postun /usr/lib64/libQHttpEngine.so.0.1.0
qhttpengine-devel.x86_64: E: useless-provides cmake(QHttpEngine)
qhttpengine-devel.x86_64: W: only-non-binary-in-usr-lib
qhttpengine-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 3 errors, 2 warnings.




Rpmlint (debuginfo)
-------------------
Checking: qhttpengine-debuginfo-0.1.0-1.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
qhttpengine-devel.x86_64: E: useless-provides cmake(QHttpEngine)
qhttpengine-devel.x86_64: W: only-non-binary-in-usr-lib
qhttpengine-devel.x86_64: W: no-documentation
qhttpengine.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libQHttpEngine.so.0.1.0 /lib64/libm.so.6
qhttpengine.x86_64: E: library-without-ldconfig-postin /usr/lib64/libQHttpEngine.so.0.1.0
qhttpengine.x86_64: E: library-without-ldconfig-postun /usr/lib64/libQHttpEngine.so.0.1.0
3 packages and 0 specfiles checked; 3 errors, 3 warnings.



Requires
--------
qhttpengine-debuginfo (rpmlib, GLIBC filtered):

qhttpengine-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    cmake
    libQHttpEngine.so.0()(64bit)
    qhttpengine

qhttpengine (rpmlib, GLIBC filtered):
    libQt5Core.so.5()(64bit)
    libQt5Core.so.5(Qt_5)(64bit)
    libQt5Core.so.5(Qt_5.6)(64bit)
    libQt5Network.so.5()(64bit)
    libQt5Network.so.5(Qt_5)(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)



Provides
--------
qhttpengine-debuginfo:
    qhttpengine-debuginfo
    qhttpengine-debuginfo(x86-64)

qhttpengine-devel:
    cmake(QHttpEngine)
    pkgconfig(QHttpEngine)
    qhttpengine-devel
    qhttpengine-devel(x86-64)

qhttpengine:
    libQHttpEngine.so.0()(64bit)
    qhttpengine
    qhttpengine(x86-64)



Source checksums
----------------
https://github.com/nitroshare/qhttpengine/archive/0.1.0/qhttpengine-0.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 6df0e2f303eb5fb80995e0322903c2991b398a0b89fb483dae7c24bdefa1eaf1
  CHECKSUM(SHA256) upstream package : 6df0e2f303eb5fb80995e0322903c2991b398a0b89fb483dae7c24bdefa1eaf1


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1354184
Buildroot used: fedora-24-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


Resolution: ALMOST GOOD

Comment 4 Igor Gnatenko 2016-07-10 13:31:26 UTC
> Requires:       cmake
also add here %{?_isa} as well, because package installs cmake files in %{_libdir}

Comment 5 Igor Gnatenko 2016-07-10 13:32:04 UTC
Raphael, would be happy if you will review simple qt package - bug qtscrob.

Comment 6 Igor Gnatenko 2016-07-10 13:32:42 UTC
https://bugzilla.redhat.com/show_bug.cgi?id=1309794

Comment 7 Raphael Groner 2016-07-10 17:49:42 UTC
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=14849719

(In reply to Igor Gnatenko from comment #2)
> > Provides:       cmake(%{modname})
> I thought that it should come automatically... Rex?

Confirmed and fixed. It's a magic internal feature of rpmbuild.
 
> > Requires:       %{name} = %{version}-%{release}
> Missing %{?_isa}

Fixed.

> > %cmake
> I would recommend to make out-of-tree builds

What are out-of-tree builds? Do you mean to not build binaries into source folder? If yes, fixed.
 
> Others from first glance looks great!

Thanks.

(In reply to Igor Gnatenko from comment #2)
> Issues:
> =======
> - ldconfig called in %post and %postun if required.
>   Note: /sbin/ldconfig not called in qhttpengine
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#Shared_Libraries
> - %check is present and all tests pass.
>   Note: test suite is not built/ran
> - qhttpengine-devel.x86_64: E: useless-provides cmake(QHttpEngine)
>   Note: yeah, remove it
> - BuildRequires: gcc-c++ is missing
> - Would be great to build docs as well

All fixed, except tests. I don't know how to build/run the tests, please help.

(In reply to Igor Gnatenko from comment #4)
> > Requires:       cmake
> also add here %{?_isa} as well, because package installs cmake files in
> %{_libdir}

Fixed.

Comment 8 Igor Gnatenko 2016-07-10 18:32:28 UTC
> All fixed, except tests. I don't know how to build/run the tests, please help.
%build
%cmake -DBUILD_TESTS=ON
%check
ctest -VV

Also documentation stuff should be fixed similar way, not by manual running doxygen. There is -DBUILD_DOC

Comment 9 Raphael Groner 2016-07-10 20:15:49 UTC
Tests and doc fixed. Sorry for being so dumb in first steps.

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=14851458

Comment 10 Igor Gnatenko 2016-07-10 20:37:33 UTC
> %{?!_pkgdocdir:%global _pkgdocdir %{_docdir}/%{name}}
could be removed

> mkdir -p %{_target_platform}
better to move into %prep

> cp -ap examples %{buildroot}%{_pkgdocdir}
just mark as %doc in -doc subpkg

> pushd %{_target_platform}/tests
> ctest %{?_smp_mflags}
don't pushd to tests, just to _target_platform
add -VV to ctest invocation to easy identify bugs if there
also do popd after

> %{_pkgdocdir}/
mark as %doc

Comment 11 Raphael Groner 2016-07-11 07:01:38 UTC
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=14855484

(In reply to Igor Gnatenko from comment #10)
> > %{?!_pkgdocdir:%global _pkgdocdir %{_docdir}/%{name}}
> could be removed

Needed for EPEL7, %{_pkgdocdir} is not defined there.

> > mkdir -p %{_target_platform}
> better to move into %prep

We don't want an empty folder created for rpmbuild -bp, it's common practice to do it so in %make.

> > cp -ap examples %{buildroot}%{_pkgdocdir}
> just mark as %doc in -doc subpkg

Guidelines forbid to mix %doc with %{_pkgdocdir}. We've to use %{_pkgdocdir} cause you instructed me to use cmake installation of documentation files, the examples folder is an addition.
https://fedoraproject.org/wiki/Packaging:Guidelines#Documentation

> > pushd %{_target_platform}/tests
> > ctest %{?_smp_mflags}
> don't pushd to tests, just to _target_platform
> add -VV to ctest invocation to easy identify bugs if there
> also do popd after

Fixed. Although, popd is obsolete. -VV does not give any obvious improvement to build.log, anyways added.

> > %{_pkgdocdir}/
> mark as %doc

Useless, see above.

Comment 12 Igor Gnatenko 2016-07-11 07:19:25 UTC
everything looks good, APPROVED.

Comment 13 Raphael Groner 2016-07-11 07:25:29 UTC
Thanks again! Removing alias to allow general search for package bugs.

Comment 14 Igor Gnatenko 2016-07-11 07:29:48 UTC
(In reply to Raphael Groner from comment #13)
> Thanks again! Removing alias to allow general search for package bugs.

I don't think that it makes sense to remove. It's easier to find review request.

Comment 15 Raphael Groner 2016-07-11 07:33:29 UTC
(In reply to Igor Gnatenko from comment #14)
> (In reply to Raphael Groner from comment #13)
> > Thanks again! Removing alias to allow general search for package bugs.
> 
> I don't think that it makes sense to remove. It's easier to find review
> request.

There's a link in PkgDB. An alias blocks RHBZ from full text search.

Comment 16 Gwyn Ciesla 2016-07-11 13:14:18 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/qhttpengine

Comment 17 Fedora Update System 2016-07-11 15:06:26 UTC
qhttpengine-0.1.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-68d6628c64

Comment 18 Fedora Update System 2016-07-11 15:06:35 UTC
qhttpengine-0.1.0-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-d951a498d5

Comment 19 Fedora Update System 2016-07-11 15:06:40 UTC
qhttpengine-0.1.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-9e775d66cb

Comment 20 Fedora Update System 2016-07-12 02:53:26 UTC
qhttpengine-0.1.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-9e775d66cb

Comment 21 Fedora Update System 2016-07-12 03:54:22 UTC
nitroshare-0.3.2-6.fc23, qhttpengine-0.1.0-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-d951a498d5

Comment 22 Fedora Update System 2016-07-12 03:58:07 UTC
nitroshare-0.3.2-6.fc24, qhttpengine-0.1.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-68d6628c64

Comment 23 Fedora Update System 2016-07-12 14:39:01 UTC
nitroshare-0.3.2-8.fc24 qhttpengine-0.1.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-68d6628c64

Comment 24 Fedora Update System 2016-07-12 14:42:09 UTC
nitroshare-0.3.2-8.fc23 qhttpengine-0.1.0-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-d951a498d5

Comment 25 Fedora Update System 2016-07-12 14:44:13 UTC
nitroshare-0.3.2-8.el7 qhttpengine-0.1.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-9e775d66cb

Comment 26 Fedora Update System 2016-07-13 01:25:05 UTC
nitroshare-0.3.2-8.fc24, qhttpengine-0.1.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-68d6628c64

Comment 27 Fedora Update System 2016-07-13 06:48:24 UTC
nitroshare-0.3.2-8.el7, qhttpengine-0.1.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-9e775d66cb

Comment 28 Fedora Update System 2016-07-13 07:26:16 UTC
nitroshare-0.3.2-8.fc23, qhttpengine-0.1.0-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-d951a498d5

Comment 29 Fedora Update System 2016-07-13 12:34:27 UTC
nitroshare-0.3.2-9.fc24 qhttpengine-0.1.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-68d6628c64

Comment 30 Fedora Update System 2016-07-13 12:37:43 UTC
nitroshare-0.3.2-9.fc23 qhttpengine-0.1.0-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-d951a498d5

Comment 31 Fedora Update System 2016-07-14 01:24:48 UTC
nitroshare-0.3.2-9.fc23, qhttpengine-0.1.0-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-d951a498d5

Comment 32 Fedora Update System 2016-07-14 01:56:22 UTC
nitroshare-0.3.2-9.fc24, qhttpengine-0.1.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-68d6628c64

Comment 33 Fedora Update System 2016-07-21 23:21:09 UTC
nitroshare-0.3.2-9.fc23, qhttpengine-0.1.0-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 34 Fedora Update System 2016-07-22 15:59:41 UTC
nitroshare-0.3.2-9.fc24, qhttpengine-0.1.0-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.